//+------------------------------------------------------------------+
//|                                                  aGannSquare.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern string Square = "A";
extern bool PrimaryAnglesOn=true;
extern bool SecondaryAnglesOn=false;
extern bool ThirdAnglesOn=false;
extern bool FourthAnglesOn=false;
extern bool InnerSquareOn=false;
extern color PrimaryColor = Red;
extern color GridColor = Gray;


datetime Time1,Time2;
double Price1,Price2,PriceUnit;
int Time1Index, Time2Index;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete(Square+"R1");
   ObjectDelete(Square+"R2");
   ObjectDelete(Square+"Top");
   ObjectDelete(Square+"Top+1");
   ObjectDelete(Square+"Bottom");
   ObjectDelete(Square+"Bottom-1");
   
   ObjectDelete(Square+"1up");
   ObjectDelete(Square+"1down");
   ObjectDelete(Square+"2down");
   ObjectDelete(Square+"2up");

   ObjectDelete(Square+"1x1");
   ObjectDelete(Square+"1/2");
   ObjectDelete(Square+"1/3");
   ObjectDelete(Square+"1/4");
   ObjectDelete(Square+"1/8");
   ObjectDelete(Square+"1/16");
   ObjectDelete(Square+"1/32");
   ObjectDelete(Square+"1/64");
   ObjectDelete(Square+"1/128");
   ObjectDelete(Square+"1/256");
   ObjectDelete(Square+"1/512");
   ObjectDelete(Square+"1/11");
   ObjectDelete(Square+"2x1");
   ObjectDelete(Square+"3x1");
   ObjectDelete(Square+"4x1");
   ObjectDelete(Square+"8x1");
   

   ObjectDelete(Square+"R1x1");
   ObjectDelete(Square+"R1/2");
   ObjectDelete(Square+"R1/3");
   ObjectDelete(Square+"R2/3");
   ObjectDelete(Square+"R1/4");
   ObjectDelete(Square+"R1/8");
   ObjectDelete(Square+"R1/16");
   ObjectDelete(Square+"R1/32");
   ObjectDelete(Square+"R1/64");
   ObjectDelete(Square+"R1/128");
   ObjectDelete(Square+"R1/256");
   ObjectDelete(Square+"R1/512");
   ObjectDelete(Square+"R1/11");
   ObjectDelete(Square+"R2x1");
   ObjectDelete(Square+"R3x1");
   ObjectDelete(Square+"R3x2");
   ObjectDelete(Square+"R4x1");
   ObjectDelete(Square+"R8x1");
   
   
   
   

   ObjectDelete(Square+"H-1/8");
   ObjectDelete(Square+"H-2/8");   
   ObjectDelete(Square+"H0/8");
   ObjectDelete(Square+"H1/8");
   ObjectDelete(Square+"H2/8");
   ObjectDelete(Square+"H3/8");
   ObjectDelete(Square+"H4/8");
   ObjectDelete(Square+"H5/8");
   ObjectDelete(Square+"H6/8");
   ObjectDelete(Square+"H7/8");
   ObjectDelete(Square+"H8/8");
   ObjectDelete(Square+"H9/8");
   ObjectDelete(Square+"H10/8");   
   
   ObjectDelete(Square+"V1/8");
   ObjectDelete(Square+"V2/8");
   ObjectDelete(Square+"V3/8");
   ObjectDelete(Square+"V4/8");
   ObjectDelete(Square+"V5/8");
   ObjectDelete(Square+"V6/8");
   ObjectDelete(Square+"V7/8");
   
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
   if(ObjectType(Square)!=OBJ_RECTANGLE) return(0);
   
   Time1 = MathMin(ObjectGet(Square,OBJPROP_TIME1),ObjectGet(Square,OBJPROP_TIME2));
   Time2 = MathMax(ObjectGet(Square,OBJPROP_TIME1),ObjectGet(Square,OBJPROP_TIME2));
   Price1 = MathMin(ObjectGet(Square,1),ObjectGet(Square,3));
   Price2 = MathMax(ObjectGet(Square,1),ObjectGet(Square,3));
   
   Time1Index=iBarShift(NULL,0,Time1);
   Time2Index=iBarShift(NULL,0,Time2);
   if(Time1Index==0 || Time2Index==0) { deinit(); Comment("Move the square bact to past"); return(0); }
      else Comment("");
   PriceUnit = (Price2-Price1)*1000/(Time1Index-Time2Index);
   
   //Alert(Time1, "-", Price1, "-", Time2, "-", Price2 );
   //Alert(Time2-Time1);
   //ObjectCreate("MedianTime", OBJ_HLINE, 0, Time1, (Price1+Price2)/2);
   //SetObj("MedianPrice", OBJ_HLINE, Time1, (Price1+Price2)/2,0,0);
   //SetObj("MedianTime", OBJ_VLINE, (Time2-Time1)/2+Time1, Price1,0,0);
   
   if(Time[Time2Index-(Time1Index-Time2Index)*2]<0)
   {
      SetObj(Square+"R1", OBJ_VLINE, Time2Index+(Time2-Time1),0,0,0, GridColor);
      SetObj(Square+"R2", OBJ_VLINE, Time2+(Time2-Time1)*2,0,0,0, GridColor);
   }else
   {
      SetObj(Square+"R1", OBJ_VLINE, getTime(Time2Index-(Time1Index-Time2Index)),0,0,0, GridColor);
      SetObj(Square+"R2", OBJ_VLINE, getTime(Time2Index-(Time1Index-Time2Index)*2),0,0,0, GridColor);
   }
   SetObj(Square+"Top+1", OBJ_HLINE, Time1, Price2+(Price2-Price1),0,0, GridColor);
   SetObj(Square+"Bottom-1", OBJ_HLINE, Time1, Price1-(Price2-Price1),0,0, GridColor);

   
   //Alert(Symbol(),PriceUnit);

//Projected Lines


   if(InnerSquareOn){
   SetObj(Square+"1up", OBJ_TREND, Time2, Price1+1*(Price2-Price1)/2, getTime(Time2Index-1*(Time1Index-Time2Index)/2), Price2, PrimaryColor);
   SetObj(Square+"1down", OBJ_TREND, Time2, Price1+1*(Price2-Price1)/2, getTime(Time2Index-1*(Time1Index-Time2Index)/2), Price1, PrimaryColor);
   SetObj(Square+"2down", OBJ_TREND, getTime(Time2Index-1*(Time1Index-Time2Index)/2), Price2, getTime(Time2Index-(Time1Index-Time2Index)), Price1+1*(Price2-Price1)/2, PrimaryColor);
   SetObj(Square+"2up", OBJ_TREND, getTime(Time2Index-1*(Time1Index-Time2Index)/2), Price1, getTime(Time2Index-(Time1Index-Time2Index)), Price1+1*(Price2-Price1)/2, PrimaryColor);
   
   
   }
   
   if(PrimaryAnglesOn){
      SetObj(Square+"1x1", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/1000, PrimaryColor);
      SetObj(Square+"1/2", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/2000, PrimaryColor);
      SetObj(Square+"1/4", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/4000, PrimaryColor);
      SetObj(Square+"1/8", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/8000, PrimaryColor);
      SetObj(Square+"2x1", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index*2/1000, PrimaryColor);
      SetObj(Square+"4x1", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index*4/1000, PrimaryColor);
      SetObj(Square+"8x1", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index*8/1000, PrimaryColor);

      SetObj(Square+"R1x1", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/1000, PrimaryColor);
      SetObj(Square+"R1/2", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/2000, PrimaryColor);
      SetObj(Square+"R1/4", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/4000, PrimaryColor);
      SetObj(Square+"R1/8", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/8000, PrimaryColor);
      SetObj(Square+"R2x1", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index*2/1000, PrimaryColor);   
      SetObj(Square+"R4x1", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index*4/1000, PrimaryColor);
      SetObj(Square+"R8x1", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index*8/1000, PrimaryColor);   
   }
   
   
   if(SecondaryAnglesOn){
   SetObj(Square+"R1/3", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/3000, PrimaryColor);
   SetObj(Square+"3x1", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index*3/1000, PrimaryColor);
   SetObj(Square+"1/3", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/3000, PrimaryColor);
   SetObj(Square+"R3x1", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index*3/1000, PrimaryColor);
   
   }
   
   SetObj(Square+"H-2/8", OBJ_TREND, Time2, Price1-4*(Price2-Price1)/8, Time[0], Price1-4*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H-1/8", OBJ_TREND, Time2, Price1-2*(Price2-Price1)/8, Time[0], Price1-2*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H0/8", OBJ_TREND, Time2, Price1, Time[0], Price1, GridColor);
   SetObj(Square+"H1/8", OBJ_TREND, Time2, Price1+(Price2-Price1)/8, Time[0], Price1+(Price2-Price1)/8, GridColor);
   SetObj(Square+"H2/8", OBJ_TREND, Time2, Price1+2*(Price2-Price1)/8, Time[0], Price1+2*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H3/8", OBJ_TREND, Time2, Price1+3*(Price2-Price1)/8, Time[0], Price1+3*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H4/8", OBJ_TREND, Time2, Price1+4*(Price2-Price1)/8, Time[0], Price1+4*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H5/8", OBJ_TREND, Time2, Price1+5*(Price2-Price1)/8, Time[0], Price1+5*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H6/8", OBJ_TREND, Time2, Price1+6*(Price2-Price1)/8, Time[0], Price1+6*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H7/8", OBJ_TREND, Time2, Price1+7*(Price2-Price1)/8, Time[0], Price1+7*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H8/8", OBJ_TREND, Time2, Price1+8*(Price2-Price1)/8, Time[0], Price1+8*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H9/8", OBJ_TREND, Time2, Price1+10*(Price2-Price1)/8, Time[0], Price1+10*(Price2-Price1)/8, GridColor);
   SetObj(Square+"H10/8", OBJ_TREND, Time2, Price1+12*(Price2-Price1)/8, Time[0], Price1+12*(Price2-Price1)/8, GridColor);   
   
   SetObj(Square+"V1/8", OBJ_VLINE, getTime(Time2Index-(Time1Index-Time2Index)/8),0,0,0, GridColor);
   SetObj(Square+"V2/8", OBJ_VLINE, getTime(Time2Index-2*(Time1Index-Time2Index)/8),0,0,0, GridColor);
   SetObj(Square+"V3/8", OBJ_VLINE, getTime(Time2Index-3*(Time1Index-Time2Index)/8),0,0,0, GridColor);
   SetObj(Square+"V4/8", OBJ_VLINE, getTime(Time2Index-4*(Time1Index-Time2Index)/8),0,0,0, GridColor);
   SetObj(Square+"V5/8", OBJ_VLINE, getTime(Time2Index-5*(Time1Index-Time2Index)/8),0,0,0, GridColor);
   SetObj(Square+"V6/8", OBJ_VLINE, getTime(Time2Index-6*(Time1Index-Time2Index)/8),0,0,0, GridColor);
   SetObj(Square+"V7/8", OBJ_VLINE, getTime(Time2Index-7*(Time1Index-Time2Index)/8),0,0,0, GridColor);
   
   if(ThirdAnglesOn){
   SetObj(Square+"R1/11", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/11000, PrimaryColor);
   SetObj(Square+"R1/16", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/16000, PrimaryColor);
   SetObj(Square+"1/11", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/11000, PrimaryColor);
   SetObj(Square+"1/16", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/16000, PrimaryColor);
   
   }
   
   if(FourthAnglesOn){
   SetObj(Square+"1/32", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/32000, PrimaryColor);
   SetObj(Square+"1/64", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/64000, PrimaryColor);
   SetObj(Square+"1/128", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/128000, PrimaryColor);
   SetObj(Square+"1/256", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/256000, PrimaryColor);
   SetObj(Square+"1/512", OBJ_TREND, Time2, Price1, Time[0], Price1+PriceUnit*Time2Index/512000, PrimaryColor);
   SetObj(Square+"R1/32", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/32000, PrimaryColor);
   SetObj(Square+"R1/64", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/64000, PrimaryColor);
   SetObj(Square+"R1/128", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/128000, PrimaryColor);
   SetObj(Square+"R1/256", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/256000, PrimaryColor);
   SetObj(Square+"R1/512", OBJ_TREND, Time2, Price2, Time[0], Price2-PriceUnit*Time2Index/512000, PrimaryColor);
   
   }
   
/*   
   SetObj("1x1", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price2);
   SetObj("1/2", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price1+(Price2-Price1)/2);
   SetObj("1/4", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price1+(Price2-Price1)/4);
   SetObj("1/8", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price1+(Price2-Price1)/8);
   SetObj("2x1", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price1+(Price2-Price1)*2);
   SetObj("3x1", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price1+(Price2-Price1)*3);
   SetObj("4x1", OBJ_TREND, Time2, Price1, Time2+(Time2-Time1), Price1+(Price2-Price1)*4);

   SetObj("R1x1", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price1);
   SetObj("R1/2", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price2-(Price2-Price1)/2);
   SetObj("R1/4", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price2-(Price2-Price1)/4);
   SetObj("R1/8", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price2-(Price2-Price1)/8);
   SetObj("R2x1", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price2-(Price2-Price1)*2);   
   SetObj("R3x1", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price2-(Price2-Price1)*3);   
   SetObj("R4x1", OBJ_TREND, Time2, Price2, Time2+(Time2-Time1), Price2-(Price2-Price1)*4);   
*/
//----
   return(0);
  }
//+------------------------------------------------------------------+

datetime getTime(int TimeIndex){
   if(TimeIndex<0){
      return(Time[0]+MathAbs(TimeIndex)*Period()*60);
   
   }
   else{
      return(Time[TimeIndex]);
   }

}


int SetObj(string Name, int ObjType, datetime Time1, double Price1, datetime Time2, double Price2, color LColor) 
{
   if(ObjectFind(Name)<0)
   {
   //object not found create new one
      if(ObjType==OBJ_VLINE)
      {
         ObjectCreate(Name, OBJ_VLINE, 0, Time1, 0);
         ObjectSet(Name, OBJPROP_COLOR, LColor);
      }
      if(ObjType==OBJ_HLINE)
      {
         ObjectCreate(Name, OBJ_HLINE, 0, 0, Price1);
         ObjectSet(Name, OBJPROP_COLOR, LColor);
      }
      if(ObjType==OBJ_TREND)
      {
         ObjectCreate(Name, OBJ_TREND, 0, Time1, Price1, Time2, Price2);

         ObjectSet(Name, OBJPROP_COLOR, LColor);         

      }   
   
   }
   else
   {
      if(ObjectType(Name)==OBJ_VLINE)
      {
         ObjectSet(Name, OBJPROP_TIME1, Time1);
         ObjectSet(Name, OBJPROP_COLOR, LColor);
      }
      if(ObjectType(Name)==OBJ_HLINE)
      {
         ObjectSet(Name, OBJPROP_PRICE1, Price1);
         ObjectSet(Name, OBJPROP_COLOR, LColor);
      }
      if(ObjectType(Name)==OBJ_TREND)
      {
         ObjectSet(Name, OBJPROP_TIME1, Time1);
         ObjectSet(Name, OBJPROP_PRICE1, Price1);
         ObjectSet(Name, OBJPROP_TIME2, Time2);
         ObjectSet(Name, OBJPROP_PRICE2, Price2);
         
         ObjectSet(Name, OBJPROP_COLOR, LColor);         

      }
   }
   return(0);
}